package com.safeway.epe.avrokafkawithoutschemaregistry;

import com.safeway.epe.avrokafkawithoutschemaregistry.configuration.KafkaProperties;
import com.safeway.epe.avrokafkawithoutschemaregistry.configuration.PropertiesConfiguration;
import com.safeway.epe.avrokafkawithoutschemaregistry.consumer.PromotionConsumer;
import com.safeway.epe.avrokafkawithoutschemaregistry.producer.PromotionProducer;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ConfigurableApplicationContext;


import java.io.IOException;
import java.util.concurrent.ExecutionException;

@SpringBootApplication
public class KafkaProducerConsumerApplication {
	private static KafkaProperties kafkaProperties;
	KafkaProducerConsumerApplication(KafkaProperties kafkaProperties)
	{
		this.kafkaProperties=kafkaProperties;
	}
	public static void main(String[] args) throws IOException, ExecutionException, InterruptedException {
		ConfigurableApplicationContext context =SpringApplication.run(KafkaProducerConsumerApplication.class, args);
		PromotionProducer promotionProducer = context.getBean(PromotionProducer.class);
		promotionProducer.sendPromotionEvent(PropertiesConfiguration.getProperties(kafkaProperties));
		PromotionConsumer promotionConsumer = context.getBean(PromotionConsumer.class);
		promotionConsumer.consumeMesage(PropertiesConfiguration.consumerProperties(kafkaProperties));
	}
}
