package com.safeway.epe.avrokafkawithoutschemaregistry.consumer;

import com.safeway.epe.avrokafkawithoutschemaregistry.configuration.KafkaProperties;
import com.safeway.epe.model.Promotion;
import lombok.extern.slf4j.Slf4j;
import org.apache.kafka.clients.consumer.ConsumerRecords;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.Duration;
import java.util.Collections;

@Slf4j
@Service
public class PromotionConsumer {
    @Autowired
    private KafkaProperties kafkaProperties;

    public ConsumerRecords<String, Promotion> consumeMesage(KafkaConsumer<String, Promotion> consumer) {
        ConsumerRecords<String, Promotion> records = null;
        consumer.subscribe(Collections.singleton(kafkaProperties.getTopic()));
        try {
            while (true) {
                records = consumer.poll(Duration.ofMillis(1000));
                records.forEach(record ->
                {
                    try {
                        log.info("Value is ::" + record.value());
                    } catch (Exception exception) {
                        log.error("Error message ::" + exception.getMessage());
                    }
                });
            }
        } catch (Exception exception) {
            log.error("Exception ::", exception.getMessage());

        } finally {
            consumer.close();
        }
        return records;
    }
}
