package com.safeway.epe.avrokafkawithoutschemaregistry.serializer;

import lombok.extern.slf4j.Slf4j;
import org.apache.avro.generic.GenericDatumReader;
import org.apache.avro.generic.GenericDatumWriter;
import org.apache.avro.io.*;
import org.apache.avro.specific.SpecificRecordBase;
import org.apache.kafka.common.serialization.Serializer;

import java.io.ByteArrayOutputStream;
import java.util.Map;

@Slf4j
public class KafkaAvroSerialize<T extends SpecificRecordBase> implements Serializer<T> {
    private BinaryEncoder encoder;

    @Override
    public void configure(Map<String, ?> arg0, boolean arg1) {
    }

    @Override
    public byte[] serialize(String topic, T data) {
        DatumReader<Object> reader = new GenericDatumReader<>(data.getSchema());
        GenericDatumWriter<Object> writer = new GenericDatumWriter<>(data.getSchema());
        ByteArrayOutputStream output = new ByteArrayOutputStream();
        Encoder encoder = EncoderFactory.get().binaryEncoder(output, this.encoder);
        try {
            writer.write(data, encoder);
            encoder.flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return output.toByteArray();
    }

    @Override
    public void close() {

    }
}