package com.safeway.epe.avrokafkawithoutschemaregistry.producer;

import com.safeway.epe.avrokafkawithoutschemaregistry.configuration.KafkaProperties;
import org.apache.kafka.clients.producer.*;
import org.apache.kafka.common.TopicPartition;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.*;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import java.io.IOException;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

@ExtendWith(SpringExtension.class)
public class PromotionProducerTest {
    private static String topic = "promotion_spark1";
    @InjectMocks
    private PromotionProducer promotionProducer;
    @Mock
    private KafkaProducer producer;
    @Mock
    private KafkaProperties kafkaProperties;
    @Test
    public void testSendPromotionEvent1() throws InterruptedException, ExecutionException, IOException {
        RecordMetadata recordMetadata = new RecordMetadata(new TopicPartition(topic, 0),
                8, 1, 342, 1111111L, -1, 581);
        CompletableFuture<RecordMetadata> future = new CompletableFuture<RecordMetadata>();
        future.complete(recordMetadata);
        Mockito.when(kafkaProperties.getTopic()).thenReturn(topic);
        Mockito.when(producer.send(Mockito.isA(ProducerRecord.class))).thenReturn(future);
        promotionProducer.sendPromotionEvent(producer);
        Mockito.verify(producer).send(Mockito.any(ProducerRecord.class));
    }
    @Test
    public void testSendPromotionEventOnFailure()
    {
        RecordMetadata recordMetadata = new RecordMetadata(new TopicPartition(topic, 0),
                8, 1, 342, 1111111L, -1, 581);
        CompletableFuture<RecordMetadata> future = new CompletableFuture<RecordMetadata>();
        future.completeExceptionally(new RuntimeException("Exception ocured"));
        Assertions.assertThrows(Exception.class ,()->promotionProducer.sendPromotionEvent(producer).get());
    }
}
